import multiprocessing as mp
import os
import random

from PIL import ImageFont

from config import *
from utils import render_text


def render_par(i):
    # Overlapped source code snapshots are allowed only for train set.
    # Images between N_SAMPLES-TEST_SET_SIZE and N_SAMPLES constitutes the test set
    test_set_size = int(N_SAMPLES * TEST_SET_SPLIT)
    train_set_size = N_SAMPLES - test_set_size
    test_set_lines = int(test_set_size * LINES_PER_IMAGE)
    if i < train_set_size:
        random.seed(i)
        start = random.randint(0, len(content) - test_set_lines - LINES_PER_IMAGE)
    else:
        start = len(content) - test_set_lines + LINES_PER_IMAGE * (i - train_set_size)

    text = ''.join(content[start: start + LINES_PER_IMAGE])

    # text_path = os.path.join(RENDERINGS_OUTPUT_FOLDER, lang, ("%04d.txt" % i))
    # with open(text_path, 'w') as f:
    #     f.write(str(start) + '\n')

    image_path = os.path.join(RENDERINGS_OUTPUT_FOLDER, lang, ("%04d.png" % i))
    render_text(text, image_path, font)


#####################################################

font = ImageFont.truetype(FONT_NAME, FONT_SIZE)

languages = []
for lang in os.listdir(BUNDLE_DATASET_PATH):
    languages.append(lang[:-4])

if not os.path.exists(RENDERINGS_OUTPUT_FOLDER):
    os.mkdir(RENDERINGS_OUTPUT_FOLDER)

print("Number of languages:", str(len(languages)))

z = 1
for lang in languages:
    print(str(z) + '. ' + lang)

    language_folder_tmp = os.path.join(RENDERINGS_OUTPUT_FOLDER, lang)
    if not os.path.exists(language_folder_tmp):
        os.mkdir(language_folder_tmp)

    with open(os.path.join(BUNDLE_DATASET_PATH, lang + '.txt')) as file:
        content = file.readlines()

    X = range(0, N_SAMPLES)

    pool = mp.Pool(mp.cpu_count())
    pool.map(render_par, X)
    pool.close()

    z += 1
